/*
 * setjmp.c
 *
 * Copyright (C) 2017 Aleksandar Andrejevic <theflash@sdf.lonestar.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <setjmp.h>
#include <monolithium.h>

int setjmp(jmp_buf env)
{
    syscall_query_thread(INVALID_HANDLE, THREAD_CPU_STATE_INFO, &env->state, sizeof(env->state));
    return env->val;
}

int longjmp(jmp_buf env, int val)
{
    env->val = val ? val : 1;
    syscall_set_thread(INVALID_HANDLE, THREAD_CPU_STATE_INFO, &env->state, sizeof(env->state));
    return -1;
}
